# uncomment and add '%' to use the prereltag for pre-releases
# %%global prereltag beta1

##-----------------------------------------------------------------------------
## All argument definitions should be placed here and keep them sorted
##

# if you wish to compile an rpm with cmocka unit testing...
# rpmbuild -ta @PACKAGE_NAME@-@PACKAGE_VERSION@.tar.gz --with cmocka
%{?_with_cmocka:%global _with_cmocka --enable-cmocka}

# if you wish to compile an rpm without rdma support, compile like this...
# rpmbuild -ta @PACKAGE_NAME@-@PACKAGE_VERSION@.tar.gz --without rdma
%{?_without_rdma:%global _without_rdma --disable-ibverbs}

# if you wish to compile an rpm without epoll...
# rpmbuild -ta @PACKAGE_NAME@-@PACKAGE_VERSION@.tar.gz --without epoll
%{?_without_epoll:%global _without_epoll --disable-epoll}

# if you wish to compile an rpm without fusermount...
# rpmbuild -ta name-version.tar.gz --without fusermount
%{?_without_fusermount:%global _without_fusermount --disable-fusermount}

# if you wish to compile an rpm without geo-replication support, compile like this...
# rpmbuild -ta name-version.tar.gz --without georeplication
%{?_without_georeplication:%global _without_georeplication --disable-georeplication}

# if you wish to compile an rpm without the OCF resource agents...
# rpmbuild -ta name-version.tar.gz --without ocf
%{?_without_ocf:%global _without_ocf --without-ocf}

# if you wish to compile an rpm without the BD map support...
# rpmbuild -ta name-version.tar.gz --without bd
%{?_without_bd:%global _without_bd --disable-bd-xlator}

# if you wish to compile an rpm without the qemu-block support...
# rpmbuild -ta name-version.tar.gz --without qemu-block
%{?_without_qemu_block:%global _without_qemu_block --disable-qemu-block}




%define	major 0
%define libname	%mklibname glusterfs %{major}
%define develname %mklibname -d glusterfs

%define libnameapi	%mklibname api %{major}
%define develnameapi %mklibname -d api

# (cg) Temporary hack to make it build
%define _disable_ld_no_undefined 1

Summary:	GlusterFS network/cluster filesystem
Name:		glusterfs
Version:	3.7.9
Release:	%mkrel 1
License:	GPLv3+
Group:		Networking/Other
URL: 		http://www.gluster.org/docs/index.phpFrundirFS
Source0:	http://download.gluster.org/pub/gluster/glusterfs/3.4/%{version}/%{name}-%{version}.tar.gz
Source1:	glusterfsd.service
Source2:	glusterfsd.sysconfig
Source3:	glusterfsd.logrotate
Source4:	glusterfs.logrotate
BuildRequires:	autoconf
BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	gcc
BuildRequires:	make
BuildRequires:	fuse-devel >= 2.6.0
BuildRequires:	libibverbs-devel
BuildRequires:	pkgconfig(libxml-2.0) >= 2.6.19
BuildRequires:  pkgconfig(liburcu-bp)
BuildRequires:	readline-devel
BuildRequires:	libtool
BuildRequires:	openssl-devel
BuildRequires:	acl-devel
BuildRequires:	python-devel
Requires(pre):    rpm-helper >= %{rpmhelper_required_version}
Requires(post):   rpm-helper >= %{rpmhelper_required_version}
Requires(post):   systemd >= %{systemd_required_version}
Requires(preun):  rpm-helper >= %{rpmhelper_required_version}
Requires(postun): rpm-helper >= %{rpmhelper_required_version}

Obsoletes:        %{name}-common < %{version}-%{release}
Obsoletes:        %{name}-core < %{version}-%{release}
Obsoletes:        %{name}-ufo
Provides:         %{name}-common = %{version}-%{release}
Provides:         %{name}-core = %{version}-%{release}

%if ( 0%{?_with_cmocka:1} )
BuildRequires:    libcmocka-devel >= 1.0.1
%endif
%if ( 0%{!?_without_tiering:1} )
BuildRequires:    sqlite3-devel
%endif
%if ( 0%{!?_without_bd:1} )
BuildRequires:    pkgconfig(lvm2app)
%endif
%if ( 0%{!?_without_qemu_block:1} )
BuildRequires:    glib2-devel
%endif
%if ( 0%{!?_without_georeplication:1} )
BuildRequires:    attr-devel
%endif

# We do not want to generate useless provides and requires for xlator .so files
# Filter all generated:
#
    # modern rpm and current Mageia do not generate requires when the
    # provides are filtered
    %global __provides_exclude_from ^%{_libdir}/glusterfs/%{version}/.*$

%description
GlusterFS is a clustered file-system capable of scaling to several
petabytes. It aggregates various storage bricks over Infiniband RDMA
or TCP/IP interconnect into one large parallel network file
system. GlusterFS is one of the most sophisticated file systems in
terms of features and extensibility.  It borrows a powerful concept
called Translators from GNU Hurd kernel. Much of the code in GlusterFS
is in user space and easily manageable.

This package includes the glusterfs binary, the glusterfsd daemon and the
gluster command line, libglusterfs and glusterfs translator modules common to
both GlusterFS server and client framework.



%package -n	%{libname}
Summary:	GlusterFS network/cluster filesystem library
Group:		System/Libraries
Provides: 	glusterfs-libs, libglusterfs

%description -n	%{libname}
GlusterFS is a clustered file-system capable of scaling to several
peta-bytes. It aggregates various storage bricks over Infiniband RDMA
or TCP/IP interconnect into one large parallel network file
system. GlusterFS is one of the most sophisticated file system in
terms of features and extensibility.  It borrows a powerful concept
called Translators from GNU Hurd kernel. Much of the code in GlusterFS
is in userspace and easily manageable.

Please visit http://www.gluster.org/docs/index.php/GlusterFS for more info.

This package includes the libglusterfs and glusterfs translator modules common
to both GlusterFS server and client framework.

%package -n	%{develname}
Summary:	Static library and header files for the GlusterFS library
Group:		Development/C
Provides:	%{name}-devel = %{version}
Requires:	%{libname} = %{version}

%description -n	%{develname}
GlusterFS is a clustered file-system capable of scaling to several
peta-bytes. It aggregates various storage bricks over Infiniband RDMA
or TCP/IP interconnect into one large parallel network file
system. GlusterFS is one of the most sophisticated file system in
terms of features and extensibility.  It borrows a powerful concept
called Translators from GNU Hurd kernel. Much of the code in GlusterFS
is in userspace and easily manageable.

%package api
Summary:          Clustered file-system api library
Group:            System/Servers
Requires:         %{name} = %{version}-%{release}
Requires:         %{name}-client-xlators = %{version}-%{release}

%description api
GlusterFS is a clustered file-system capable of scaling to several
petabytes. It aggregates various storage bricks over Infiniband RDMA
or TCP/IP interconnect into one large parallel network file
system. GlusterFS is one of the most sophisticated file systems in
terms of features and extensibility.  It borrows a powerful concept
called Translators from GNU Hurd kernel. Much of the code in GlusterFS
is in user space and easily manageable.

This package provides the glusterfs libgfapi library.

This package provides the development libraries and include files.
%package   -n     %{develnameapi}
Summary:          Development/C
Group:            System/Libraries
Requires:         %{name} = %{version}-%{release}
Requires:         %{name}-devel = %{version}-%{release}
Requires:         libacl-devel

%description -n     %{develnameapi}
GlusterFS is a clustered file-system capable of scaling to several
petabytes. It aggregates various storage bricks over Infiniband RDMA
or TCP/IP interconnect into one large parallel network file
system. GlusterFS is one of the most sophisticated file systems in
terms of features and extensibility.  It borrows a powerful concept
called Translators from GNU Hurd kernel. Much of the code in GlusterFS
is in user space and easily manageable.

This package provides the api include files.

%package cli
Summary:          GlusterFS CLI
Group:            File tools
Requires:         %{name}-libs = %{version}-%{release}

%description cli
GlusterFS is a clustered file-system capable of scaling to several
petabytes. It aggregates various storage bricks over Infiniband RDMA
or TCP/IP interconnect into one large parallel network file
system. GlusterFS is one of the most sophisticated file systems in
terms of features and extensibility.  It borrows a powerful concept
called Translators from GNU Hurd kernel. Much of the code in GlusterFS
is in user space and easily manageable.

This package provides the GlusterFS CLI application and its man page

%package client-xlators
Summary:          GlusterFS client-side translators
Group:            Networking/Other

%description client-xlators
GlusterFS is a distributed file-system capable of scaling to several
petabytes. It aggregates various storage bricks over Infiniband RDMA
or TCP/IP interconnect into one large parallel network file
system. GlusterFS is one of the most sophisticated file systems in
terms of features and extensibility.  It borrows a powerful concept
called Translators from GNU Hurd kernel. Much of the code in GlusterFS
is in user space and easily manageable.

This package provides the translators needed on any GlusterFS client.

%package          extra-xlators
Summary:          Extra Gluster filesystem Translators
Group:            File tools
# We need -api rpm for its __init__.py in Python site-packages area
Requires:         %{name}-api = %{version}-%{release}
Requires:         python python-ctypes

%description extra-xlators
GlusterFS is a clustered file-system capable of scaling to several
petabytes. It aggregates various storage bricks over Infiniband RDMA
or TCP/IP interconnect into one large parallel network file
system. GlusterFS is one of the most sophisticated file systems in
terms of features and extensibility.  It borrows a powerful concept
called Translators from GNU Hurd kernel. Much of the code in GlusterFS
is in user space and easily manageable.

This package provides extra filesystem Translators, such as Glupy,
for GlusterFS.

%package fuse
Summary:          Fuse client
Group:            Networking/Other
BuildRequires:    fuse-devel

Requires:         %{name} = %{version}-%{release}
Requires:         %{name}-client-xlators = %{version}-%{release}

Obsoletes:        %{name}-client < %{version}-%{release}
Provides:         %{name}-client = %{version}-%{release}

%description fuse
GlusterFS is a clustered file-system capable of scaling to several
petabytes. It aggregates various storage bricks over Infiniband RDMA
or TCP/IP interconnect into one large parallel network file
system. GlusterFS is one of the most sophisticated file systems in
terms of features and extensibility.  It borrows a powerful concept
called Translators from GNU Hurd kernel. Much of the code in GlusterFS
is in user space and easily manageable.

This package provides support to FUSE based clients.

%package ganesha
Summary:          NFS-Ganesha configuration
Group:            File tools

Requires:         %{name}-server = %{version}-%{release}
Requires:         nfs-ganesha-gluster
Requires:         pcs

%description ganesha
GlusterFS is a distributed file-system capable of scaling to several
petabytes. It aggregates various storage bricks over Infiniband RDMA
or TCP/IP interconnect into one large parallel network file
system. GlusterFS is one of the most sophisticated file systems in
terms of features and extensibility.  It borrows a powerful concept
called Translators from GNU Hurd kernel. Much of the code in GlusterFS
is in user space and easily manageable.

This package provides the configuration and related files for using
NFS-Ganesha as the NFS server using GlusterFS


%if ( 0%{!?_without_georeplication:1} )
%package geo-replication
Summary:          GlusterFS Geo-replication
Group:            Networking/Other
Requires:         %{name} = %{version}-%{release}
Requires:         %{name}-server = %{version}-%{release}
Requires:         python python-ctypes
Requires:         rsync

%description geo-replication
GlusterFS is a distributed file-system capable of scaling to several
peta-bytes. It aggregates various storage bricks over Infiniband RDMA
or TCP/IP interconnect into one large parallel network file
system. GlusterFS is one of the most sophisticated file system in
terms of features and extensibility.  It borrows a powerful concept
called Translators from GNU Hurd kernel. Much of the code in GlusterFS
is in userspace and easily manageable.

This package provides support to geo-replication.
%endif

%package -n python-gluster
Summary:          GlusterFS python library
Group:            Development/Tools
License:          GPLv3+
Requires:         python
BuildArch:        noarch


%description -n python-gluster
GlusterFS is a distributed file-system capable of scaling to several
petabytes. It aggregates various storage bricks over Infiniband RDMA
or TCP/IP interconnect into one large parallel network file
system. GlusterFS is one of the most sophisticated file systems in
terms of features and extensibility.  It borrows a powerful concept
called Translators from GNU Hurd kernel. Much of the code in GlusterFS
is in user space and easily manageable.

This package contains the python modules of GlusterFS and own gluster
namespace.

%if ( 0%{!?_without_rdma:1} )
%package rdma
Summary:          GlusterFS rdma support for ib-verbs
Group:            System/Libraries
BuildRequires:    libibverbs-devel
BuildRequires:    librdmacm-devel
Requires:         %{name} = %{version}-%{release}

%description rdma
GlusterFS is a clustered file-system capable of scaling to several
petabytes. It aggregates various storage bricks over Infiniband RDMA
or TCP/IP interconnect into one large parallel network file
system. GlusterFS is one of the most sophisticated file systems in
terms of features and extensibility.  It borrows a powerful concept
called Translators from GNU Hurd kernel. Much of the code in GlusterFS
is in user space and easily manageable.

This package provides support to ib-verbs library.
%endif

%package regression-tests
Summary:          Development Tools
Group:            Development/Tools
Requires:         %{name} = %{version}-%{release}
Requires:         %{name}-fuse = %{version}-%{release}
Requires:         %{name}-server = %{version}-%{release}
## thin provisioning support
Requires:         lvm2 >= 2.02.89
Requires:         perl(App::Prove) perl(Test::Harness) gcc util-linux-ng
Requires:         python attr dbench file git libacl-devel net-tools
Requires:         nfs-utils xfsprogs yajl

%description regression-tests
The Gluster Test Framework, is a suite of scripts used for
regression testing of Gluster.

%if ( 0%{!?_without_ocf:1} )
%package resource-agents
Summary:          OCF Resource Agents for GlusterFS
License:          GPLv3+
BuildArch:        noarch
Group:            Networking/Other
# for glusterd
Requires:         %{name}-server
# depending on the distribution, we need pacemaker or resource-agents
Requires:         %{_prefix}/lib/ocf/resource.d

%description resource-agents
GlusterFS is a distributed file-system capable of scaling to several
petabytes. It aggregates various storage bricks over Infiniband RDMA
or TCP/IP interconnect into one large parallel network file
system. GlusterFS is one of the most sophisticated file systems in
terms of features and extensibility.  It borrows a powerful concept
called Translators from GNU Hurd kernel. Much of the code in GlusterFS
is in user space and easily manageable.

This package provides the resource agents which plug glusterd into
Open Cluster Framework (OCF) compliant cluster resource managers,
like Pacemaker.
%endif

%package	server
Summary:	Clustered file-system server
Group:		Networking/Other
Requires:	%{name} = %{version}-%{release}
Requires:       %{name}-libs = %{version}-%{release}
Requires:       %{name}-cli = %{version}-%{release}
# some daemons (like quota) use a fuse-mount, glusterfsd is part of -fuse
Requires:       %{name}-fuse = %{version}-%{release}
# self-heal daemon, rebalance, nfs-server etc. are actually clients
Requires:       %{name}-client-xlators = %{version}-%{release}
# psmisc for killall, lvm2 for snapshot, and nfs-utils and
# and rpcbind/portmap for gnfs server
Requires:       psmisc
Requires:       lvm2
Requires:       nfs-utils
Requires:       rpcbind
Requires:       pyxattr
Requires(post): systemd >= %{systemd_required_version}
Requires(post): rpm-helper
Requires(preun): rpm-helper

%description	server
GlusterFS is a clustered file-system capable of scaling to several
peta-bytes. It aggregates various storage bricks over Infiniband RDMA
or TCP/IP interconnect into one large parallel network file
system. GlusterFS is one of the most sophisticated file system in
terms of features and extensibility.  It borrows a powerful concept
called Translators from GNU Hurd kernel. Much of the code in GlusterFS
is in userspace and easily manageable.

This package provides the glusterfs server daemon.

%prep
%setup -q %{name}-%{version}
cp %{SOURCE2} glusterfsd.sysconfig
cp %{SOURCE3} glusterfsd.logrotate
cp %{SOURCE4} glusterfs.logrotate

%build
%serverbuild
%configure2_5x \
        --sbindir=%{_sbindir} \
        --with-tmpfilesdir=%{_tmpfilesdir}
        %{?_with_cmocka} \
        %{?_without_bd} \
        %{?_without_epoll} \
        %{?_without_fusermount} \
        %{?_without_georeplication} \
        %{?_without_ocf} \
        %{?_without_qemu_block} \
        %{?_without_rdma} \
        %{?_without_syslog} \
        %{?_without_systemtap} \
        %{?_without_tiering}
               
# Remove rpath
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

%make

# Build Glupy
pushd xlators/features/glupy/src
FLAGS="$RPM_OPT_FLAGS" %{__python2} setup.py build
popd

%check
make check

%install
%make_install
# install the Glupy Python library in /usr/lib/python*/site-packages
pushd xlators/features/glupy/src
%{__python2} setup.py install --skip-build --verbose --root %{buildroot}
popd
# Install include directory
mkdir -p %{buildroot}%{_includedir}/glusterfs
install -p -m 0644 libglusterfs/src/*.h \
    %{buildroot}%{_includedir}/glusterfs/
install -p -m 0644 contrib/uuid/*.h \
    %{buildroot}%{_includedir}/glusterfs/
# Following needed by hekafs multi-tenant translator
mkdir -p %{buildroot}%{_includedir}/glusterfs/rpc
install -p -m 0644 rpc/rpc-lib/src/*.h \
    %{buildroot}%{_includedir}/glusterfs/rpc/
install -p -m 0644 rpc/xdr/src/*.h \
    %{buildroot}%{_includedir}/glusterfs/rpc/
mkdir -p %{buildroot}%{_includedir}/glusterfs/server
install -p -m 0644 xlators/protocol/server/src/*.h \
    %{buildroot}%{_includedir}/glusterfs/server/
install -D -p -m 0644 extras/glusterd-sysconfig \
    %{buildroot}%{_sysconfdir}/sysconfig/glusterd

mkdir -p %{buildroot}%{_logdir}/glusterd
mkdir -p %{buildroot}%{_logdir}/glusterfs
mkdir -p %{buildroot}%{_logdir}/glusterfsd
mkdir -p %{buildroot}%{_rundir}/gluster
touch %{buildroot}%{python_sitelib}/gluster/__init__.py
    

# Remove unwanted files from all the shared libraries
find %{buildroot}%{_libdir} -name '*.a' -delete
find %{buildroot}%{_libdir} -name '*.la' -delete

# Remove installed docs, the ones we want are included by %%doc, in
# /usr/share/doc/glusterfs or /usr/share/doc/glusterfs-x.y.z depending
# on the distribution
rm -rf %{buildroot}%{_pkgdocdir}/*

head -50 ChangeLog > ChangeLog.head && mv ChangeLog.head ChangeLog
cat << EOM >> ChangeLog

More commit messages for this ChangeLog can be found at
https://forge.gluster.org/glusterfs-core/glusterfs/commits/v%{version}%{?prereltag}
EOM

# Remove benchmarking and other unpackaged files
rm -rf %{buildroot}%{_defaultdocdir}/%{name}/benchmarking
rm -f %{buildroot}%{_defaultdocdir}/%{name}/glusterfs-mode.el
rm -f %{buildroot}%{_defaultdocdir}/%{name}/glusterfs.vim


# Create working directory
mkdir -p %{buildroot}/var/lib/glusterd

# Update configuration file to /var/lib working directory
sed -i 's|option working-directory /etc/glusterd|option working-directory /var/lib/glusterd|g' \
    %{buildroot}%{_sysconfdir}/glusterfs/glusterd.vol


install -D -p -m 0644 extras/glusterfs-logrotate \
    %{buildroot}%{_sysconfdir}/logrotate.d/glusterfs

%if ( 0%{!?_without_georeplication:1} )
# geo-rep ghosts
mkdir -p %{buildroot}/var/lib/glusterd/geo-replication
touch %{buildroot}/var/lib/glusterd/geo-replication/gsyncd_template.conf
install -D -p -m 0644 extras/glusterfs-georep-logrotate \
    %{buildroot}%{_sysconfdir}/logrotate.d/glusterfs-georep
%endif
    
install -D -p -m 0644 extras/logger.conf.example \
    %{buildroot}%{_sysconfdir}/glusterfs/logger.conf.example

# the rest of the ghosts
touch %{buildroot}/var/lib/glusterd/glusterd.info
touch %{buildroot}/var/lib/glusterd/options
mkdir -p %{buildroot}/var/lib/glusterd/hooks
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/stop
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/stop/post
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/stop/pre
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/start
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/start/post
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/start/pre
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/reset
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/reset/post
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/reset/pre
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/remove-brick
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/remove-brick/post
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/remove-brick/pre
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/add-brick
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/add-brick/post
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/add-brick/pre
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/set
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/set/post
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/set/pre
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/create
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/create/post
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/create/pre
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/delete
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/delete/post
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/delete/pre
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/copy-file
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/copy-file/post
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/copy-file/pre
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/gsync-create
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/gsync-create/post
mkdir -p %{buildroot}/var/lib/glusterd/hooks/1/gsync-create/pre
mkdir -p %{buildroot}/var/lib/glusterd/glustershd
mkdir -p %{buildroot}/var/lib/glusterd/peers
mkdir -p %{buildroot}/var/lib/glusterd/vols
mkdir -p %{buildroot}/var/lib/glusterd/nfs/run
touch %{buildroot}/var/lib/glusterd/nfs/nfs-server.vol
touch %{buildroot}/var/lib/glusterd/nfs/run/nfs.pid

%{__install} -p -m 0744 extras/hook-scripts/start/post/*.sh   \
    %{buildroot}/var/lib/glusterd/hooks/1/start/post
%{__install} -p -m 0744 extras/hook-scripts/stop/pre/*.sh   \
    %{buildroot}/var/lib/glusterd/hooks/1/stop/pre
%{__install} -p -m 0744 extras/hook-scripts/set/post/*.sh   \
    %{buildroot}/var/lib/glusterd/hooks/1/set/post
%{__install} -p -m 0744 extras/hook-scripts/add-brick/post/*.sh   \
    %{buildroot}/var/lib/glusterd/hooks/1/add-brick/post
%{__install} -p -m 0744 extras/hook-scripts/add-brick/pre/*.sh   \
    %{buildroot}/var/lib/glusterd/hooks/1/add-brick/pre
%{__install} -p -m 0744 extras/hook-scripts/reset/post/*.sh   \
    %{buildroot}/var/lib/glusterd/hooks/1/reset/post

find ./tests ./run-tests.sh -type f | cpio -pd %{buildroot}%{_prefix}/share/glusterfs


## Remove /xlator/encryption/crypt.so, we have a system file (/usr/lib64/libcrypt.so)
## Fedora installs it on their old releases only
rm %{buildroot}%{_libdir}/glusterfs/%version/xlator/encryption/crypt.so

## Install bash completion for cli
install -p -m 0744 -D extras/command-completion/gluster.bash \
    %{buildroot}%{_sysconfdir}/bash_completion.d/gluster

mv %{buildroot}/var/lib/glusterd/hooks/1/delete/post/S57glusterfind-delete-post.* %{buildroot}%{_libexecdir}/glusterfs/
ln -s %{_libexecdir}/glusterfs/S57glusterfind-delete-post.py %{buildroot}/var/lib/glusterd/hooks/1/delete/post/S57glusterfind-delete-post.py



##-----------------------------------------------------------------------------
## All %post should be placed here and keep them sorted
##


%if ( 0%{!?_without_georeplication:1} )
%post geo-replication
#restart glusterd.
if [ $1 -ge 1 ]; then
    %_init_restart glusterd
fi
%endif

%post server
%create_ghostfile %{_logdir}/glusterfs/glusterfsd.log root root 0644

%_post_service %{name}d

%_post_service glusterd
if [ -e /etc/glusterfs/glusterfs-server.vol ]; then 
echo "Updating /etc/sysconfig/glusterfsd to point to old /etc/glusterfs/glusterfs-server.vol file"
sed -i 's|GLUSTERFSD_CONFIG_FILE="/etc/glusterfs/glusterfsd.vol"|GLUSTERFSD_CONFIG_FILE="/etc/glusterfs/glusterfs-server.vol"|g' /etc/sysconfig/glusterfsd
#   mv -n /etc/glusterfs/glusterfs-server.vol /etc/glusterfs/glusterfsd.vol
fi

##-----------------------------------------------------------------------------
## All %preun should be placed here and keep them sorted
##

## This may needs to be looked at. Fedora's is very different
%preun server
%_preun_service glusterfsd


##-----------------------------------------------------------------------------
## All %%files should be placed here and keep them sorted by groups
##

%files
%doc ChangeLog COPYING-GPLV2 COPYING-LGPLV3 INSTALL README.md THANKS
%{_mandir}/man8/*gluster*.8*
%exclude %{_mandir}/man8/gluster.8*
%dir %{_logdir}/glusterfs
%if ( 0%{!?_without_rdma:1} )
%exclude %{_libdir}/glusterfs/%{version}%{?prereltag}/rpc-transport/rdma*
%endif
%dir %{_datadir}/glusterfs/scripts
%{_datadir}/glusterfs/scripts/post-upgrade-script-for-quota.sh
%{_datadir}/glusterfs/scripts/pre-upgrade-script-for-quota.sh
# xlators that are needed on the client- and on the server-side
%dir %{_libdir}/glusterfs/%{version}%{?prereltag}/auth
%{_libdir}/glusterfs/%{version}%{?prereltag}/auth/addr.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/auth/login.so
%dir %{_libdir}/glusterfs/%{version}%{?prereltag}/rpc-transport
%{_libdir}/glusterfs/%{version}%{?prereltag}/rpc-transport/socket.so
%dir %{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/debug
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/debug/error-gen.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/debug/io-stats.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/debug/trace.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/access-control.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/barrier.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/cdc.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/changelog.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/gfid-access.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/read-only.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/shard.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/snapview-client.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/worm.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/meta.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/performance/io-cache.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/performance/io-threads.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/performance/md-cache.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/performance/open-behind.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/performance/quick-read.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/performance/read-ahead.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/performance/readdir-ahead.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/performance/stat-prefetch.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/performance/write-behind.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/system/posix-acl.so
%{_libexecdir}/glusterfs/gfind_missing_files
%{_sbindir}/gfind_missing_files


%files -n %{libname}
%{_libdir}/*.so.*
%exclude %{_libdir}/libgfapi.*
# libgfdb is only needed server-side
%if ( 0%{!?_without_tiering:1} )
# libgfdb is only needed server-side
%exclude %{_libdir}/libgfdb.*
%endif

%files -n %{develname}
%{_includedir}/glusterfs
%exclude %{_includedir}/glusterfs/y.tab.h
%exclude %{_includedir}/glusterfs/api
%exclude %{_libdir}/libgfapi.so
%{_libdir}/*.so
# Glupy Translator examples
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/glupy/debug-trace.*
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/glupy/helloworld.*
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/glupy/negative.*
%{_libdir}/pkgconfig/libgfchangelog.pc
%if ( 0%{!?_without_tiering:1} )
%{_libdir}/pkgconfig/libgfdb.pc
%endif

%files api
%exclude %{_libdir}/*.so
# libgfapi files
%{_libdir}/libgfapi.*
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/mount/api.so

%files -n %{develnameapi}
%{_libdir}/pkgconfig/glusterfs-api.pc
%{_libdir}/libgfapi.so
%{_includedir}/glusterfs/api/*

%files cli
%{_sbindir}/gluster
%{_mandir}/man8/gluster.8*
%{_sysconfdir}/bash_completion.d/gluster

%files client-xlators
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/cluster/*.so
%exclude %{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/cluster/pump.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/ganesha.so
%if ( 0%{!?_without_qemu_block:1} )
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/qemu-block.so
%endif
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/protocol/client.so

%files regression-tests
%{_prefix}/share/glusterfs/*
%exclude %{_prefix}/share/glusterfs/tests/basic/rpm.t

%files extra-xlators
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/encryption/rot-13.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/glupy.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/mac-compat.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/prot_client.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/prot_dht.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/prot_server.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/quiesce.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/testing/features/template.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/testing/performance/symlink-cache.so
# Glupy Python files
%{python_sitelib}/gluster/glupy/*
%{python_sitelib}/glusterfs_glupy*.egg-info


%files fuse
# glusterfs is a symlink to glusterfsd, -server depends on -fuse.
%{_sbindir}/glusterfs
%{_sbindir}/glusterfsd
%config(noreplace) %{_sysconfdir}/logrotate.d/glusterfs
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/mount/fuse.so
/sbin/mount.glusterfs
%if ( 0%{!?_without_fusermount:1} )
%{_bindir}/fusermount-glusterfs
%endif


%files ganesha
%{_sysconfdir}/ganesha/*
%attr(0755,-,-) %{_libexecdir}/ganesha/*
%attr(0755,-,-) %{_prefix}/lib/ocf/resource.d/heartbeat/*


%if ( 0%{!?_without_georeplication:1} )
%files geo-replication
%config(noreplace) %{_sysconfdir}/logrotate.d/glusterfs-georep
%{_libexecdir}/glusterfs/gsyncd
%{_libexecdir}/glusterfs/python/syncdaemon/*
%{_libexecdir}/glusterfs/gverify.sh
%{_libexecdir}/glusterfs/set_geo_rep_pem_keys.sh
%{_libexecdir}/glusterfs/peer_gsec_create
%{_libexecdir}/glusterfs/peer_mountbroker
%ghost %dir %attr(0755,-,-) /var/lib/glusterd/geo-replication
%dir /var/lib/glusterd/hooks
%dir /var/lib/glusterd/hooks/1
%dir /var/lib/glusterd/hooks/1/gsync-create
%dir /var/lib/glusterd/hooks/1/gsync-create/post
/var/lib/glusterd/hooks/1/gsync-create/post/S56glusterd-geo-rep-create-post.sh
%{_datadir}/glusterfs/scripts/get-gfid.sh
%{_datadir}/glusterfs/scripts/slave-upgrade.sh
%{_datadir}/glusterfs/scripts/gsync-upgrade.sh
%{_datadir}/glusterfs/scripts/generate-gfid-file.sh
%{_datadir}/glusterfs/scripts/gsync-sync-gfid
%ghost %attr(0644,-,-) /var/lib/glusterd/geo-replication/gsyncd_template.conf
%endif

%files -n python-gluster
# introducing glusterfs module in site packages.
# so that all other gluster submodules can reside in the same namespace.
%{python_sitelib}/gluster/__init__.*

%if ( 0%{!?_without_rdma:1} )
%files rdma
%{_libdir}/glusterfs/%{version}%{?prereltag}/rpc-transport/rdma*
%endif

%if ( 0%{!?_without_ocf:1} )
%files resource-agents
# /usr/lib is the standard for OCF, also on x86_64
%{_prefix}/lib/ocf/resource.d/glusterfs
%endif

%files server
%doc extras/clear_xattrs.sh
%config(noreplace) %{_sysconfdir}/sysconfig/glusterd
%config(noreplace) %{_sysconfdir}/glusterfs
%ghost %dir %{_rundir}/gluster
%{_tmpfilesdir}/gluster.conf
%dir /var/lib/glusterd
%dir /var/lib/glusterd/groups
%config(noreplace) /var/lib/glusterd/groups/virt

%config /var/lib/glusterd/hooks/1/add-brick/pre/S28Quota-enable-root-xattr-heal.sh
%config /var/lib/glusterd/hooks/1/add-brick/post/disabled-quota-root-xattr-heal.sh
%config /var/lib/glusterd/hooks/1/set/post/S30samba-set.sh
%config /var/lib/glusterd/hooks/1/set/post/S32gluster_enable_shared_storage.sh
%config /var/lib/glusterd/hooks/1/start/post/S29CTDBsetup.sh
%config /var/lib/glusterd/hooks/1/start/post/S30samba-start.sh
%config /var/lib/glusterd/hooks/1/start/post/S31ganesha-start.sh
%config /var/lib/glusterd/hooks/1/stop/pre/S30samba-stop.sh
%config /var/lib/glusterd/hooks/1/stop/pre/S29CTDB-teardown.sh
%config /var/lib/glusterd/hooks/1/reset/post/S31ganesha-reset.sh
# init files
%{_unitdir}/glusterd.service

# binaries
%{_sbindir}/glusterd
%{_sbindir}/glfsheal
# {_sbindir}/glusterfsd is the actual binary, but glusterfs (client) is a
# symlink. The binary itself (and symlink) are part of the glusterfs-fuse
# package, because glusterfs-server depends on that anyway.
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/cluster/pump.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/arbiter.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/bit-rot.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/bitrot-stub.so
%if ( 0%{!?_without_tiering:1} )
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/changetimerecorder.so
%endif
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/index.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/locks.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/posix*
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/snapview-server.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/marker.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/quota*
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/trash.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/features/upcall.so
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/mgmt*
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/nfs*
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/protocol/server*
%{_libdir}/glusterfs/%{version}%{?prereltag}/xlator/storage*
%if ( 0%{!?_without_tiering:1} )
%{_libdir}/libgfdb.so.*
%endif

#snap_scheduler
%{_sbindir}/snap_scheduler.py
%{_sbindir}/gcron.py

#hookscripts
%dir %attr(0755,-,-) /var/lib/glusterd/hooks
%dir %attr(0755,-,-) /var/lib/glusterd/hooks/1
%dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/add-brick
%dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/add-brick/post
%dir %attr(0755,-,-) /var/lib//glusterd/hooks/1/add-brick/pre
%dir %attr(0755,-,-) /var/lib//glusterd/hooks/1/set
%dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/set/post
%dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/start
%dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/start/post
%dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/stop
%dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/stop/pre
%dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/delete
%dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/delete/post

%ghost %attr(0644,-,-) %config(noreplace) /var/lib/glusterd/glusterd.info
%ghost %attr(0600,-,-) /var/lib/glusterd/options
# This is really ugly, but I have no idea how to mark these directories in
# any other way. They should belong to the glusterfs-server package, but
# don't exist after installation. They are generated on the first start...
%ghost %dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/stop/post
%ghost %dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/start/pre
%ghost %dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/remove-brick
%ghost %dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/remove-brick/post
%ghost %dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/remove-brick/pre
%ghost %dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/set/pre
%ghost %dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/reset/pre
%ghost %dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/create
%ghost %dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/create/post
%ghost %dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/create/pre
%ghost %dir %attr(0755,-,-) /var/lib/glusterd/hooks/1/delete/pre
%ghost %dir %attr(0755,-,-) /var/lib/glusterd/glustershd
%ghost %dir %attr(0755,-,-) /var/lib/glusterd/vols
%ghost %dir %attr(0755,-,-) /var/lib/glusterd/peers
%ghost %dir %attr(0755,-,-) /var/lib/glusterd/nfs
%ghost      %attr(0600,-,-) /var/lib/glusterd/nfs/nfs-server.vol
%ghost %dir %attr(0755,-,-) /var/lib/glusterd/nfs/run
%ghost      %attr(0600,-,-) /var/lib/glusterd/nfs/run/nfs.pid

# Extra utility script
%{_datadir}/glusterfs/scripts/stop-all-gluster-processes.sh

# Incrementalapi
%{_libexecdir}/glusterfs/glusterfind
%{_bindir}/glusterfind
%{_libexecdir}/glusterfs/peer_add_secret_pub
/var/lib/glusterd/hooks/1/delete/post/S57glusterfind-delete-post.*
%{_libexecdir}/glusterfs/S57glusterfind-delete-post.*


%changelog
* Thu Mar 24 2016 spuhler <spuhler> 3.7.9-1.mga6
+ Revision: 994699
- upgrade to vers. 3.7.9

* Wed Mar 02 2016 umeabot <umeabot> 3.7.8-2.mga6
+ Revision: 983438
- Rebuild for openssl

* Thu Feb 25 2016 spuhler <spuhler> 3.7.8-1.mga6
+ Revision: 979268
- version added in "rm %%{buildroot}%%{_libdir}/glusterfs/%%version/xlator/encryption/crypt.so"
-u pgrade to vers. 3.7.8

* Thu Jan 07 2016 spuhler <spuhler> 3.7.6-2.mga6
+ Revision: 920193
- rebuild for new iburcu-bp

* Sun Dec 06 2015 spuhler <spuhler> 3.7.6-1.mga6
+ Revision: 908505
- updated rm %%{buildroot}%%{_libdir}/glusterfs/3.7.6/xlator/encryption/crypt.so to current version
- upgrade to vers. 3.7.6

* Wed Oct 21 2015 spuhler <spuhler> 3.7.5-1.mga6
+ Revision: 893160
- made %%dir %%{_rundir}/gluster a %%ghost
- removed comment on ## mkdir -p %%{buildroot}%%{_rundir}/gluster
- removed empty %%post fuse
- commented out mkdir -p %%{buildroot}%%{_rundir}/gluster
  * I don't know why Fedora used this line
-- added more ByuildReqires
- added BuildRequires: sqlite3-devel
- added BuildRequires: acl-devel
- upgrade and first build of vers. Version 3.7.5
  * specfile synched with Fedora's
- update to vers. 3.7.4

* Tue Mar 24 2015 spuhler <spuhler> 3.5.2-8.mga5
+ Revision: 819182
- added multifrag patch from OpenSuSE
  * fixes bug #15473 CVE-2014-3619

* Wed Oct 15 2014 umeabot <umeabot> 3.5.2-7.mga5
+ Revision: 743056
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 3.5.2-6.mga5
+ Revision: 726353
- rebuild for missing pythoneggs deps

* Fri Sep 19 2014 spuhler <spuhler> 3.5.2-5.mga5
+ Revision: 697392
- removed the upstream provided file glusterd.service
- removed un-used %%{_unitdir}/glusterd.service
  * it was executable

* Tue Sep 16 2014 umeabot <umeabot> 3.5.2-4.mga5
+ Revision: 679666
- Mageia 5 Mass Rebuild

* Sat Sep 13 2014 spuhler <spuhler> 3.5.2-3.mga5
+ Revision: 675175
-removed %%_tmpfilescreate in %%post server
 * we removed this file

* Thu Sep 11 2014 spuhler <spuhler> 3.5.2-2.mga5
+ Revision: 674620
- added BuildRequires: python-devel
  * needed to build glupy
- added the missing fuse package
- added the build options similar to Fedora
- added the missing logrotate files
- removed the unneeded tempfiles

* Sat Sep 06 2014 spuhler <spuhler> 3.5.2-1.mga5
+ Revision: 672496
- more Group correction
- remove /var/run/gluster file
- corrected the Groups
- more glupy files missing
- commented out glupy* to make it build
- changed %%make to make
  * it doesn't build glupy.so on the BS but does so locally
- upgrade to version 3.5.2
  * spec file based on upstream and Fedora
- use of .service file from Fedora. This seems to be more stable
- let it run as glusterfsd  glusterfsd

* Sat Nov 30 2013 thatsamguy <thatsamguy> 3.4.1-1.mga4
+ Revision: 554136
- update version to 3.4.1

* Sat Oct 19 2013 umeabot <umeabot> 3.4.0-2.mga4
+ Revision: 533551
- Mageia 4 Mass Rebuild

* Sun Sep 01 2013 fwang <fwang> 3.4.0-1.mga4
+ Revision: 473850
- update file list
- drop unneeded dir
- new version 3.4.0

* Sun Mar 24 2013 colin <colin> 3.3.1-2.mga3
+ Revision: 404859
- Add systemd requires and general post/pre fixes (mga#9302)

* Thu Jan 17 2013 colin <colin> 3.3.1-1.mga3
+ Revision: 388939
- Add openssl-devel BR
- New version: 3.3.1
- Rediff workingdir patch
- Drop patches no longer apply (shouldn't be needed now)
- Add geo-replication sub-package
- Don't ship mount command in / (use /usr)
- Fix file lists (man page dropped)
- Switch to tmpfiles for /run dir

  + umeabot <umeabot>
    - Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

  + fwang <fwang>
    - br readline
    - br xml
    - new version 3.2.6

* Mon Aug 01 2011 fwang <fwang> 3.2.2-1.mga2
+ Revision: 131097
- new version 3.2.2

* Sun Apr 10 2011 ennael <ennael> 3.0.0-2.mga1
+ Revision: 82867
- clean spec file
- imported package glusterfs

